#include "Animator.h"

#include <cassert>

Animator::Animator()
{
}

float Animator::time() const
{
    return m_time;
}

float Animator::angleVelocityDegreePerSecond() const
{
    return m_angleVelocityDegreePerSecond;
}

float Animator::currentAngleDegree() const
{
    return m_currentAngleDegree;
}

void Animator::setCurrentAngleDegree(float a)
{
    m_currentAngleDegree = a;
    assert("post: is_set" && currentAngleDegree() == a);
}

void Animator::setAngleVelocityDegreePerSecond(float velocity)
{
    m_angleVelocityDegreePerSecond = velocity;
    assert("post: is_set" && angleVelocityDegreePerSecond() == velocity);
}

void Animator::setTime(float t)
{
    m_time = t;
    assert("post: is_set" && time() == t);
}

void Animator::animate(float new_time)
{
    float duration = new_time - m_time;
    m_currentAngleDegree += m_angleVelocityDegreePerSecond * duration;
    m_time = new_time;
}
