#include "Renderer.h"

#include "RendererPrivate.h"

#include <cassert>

Renderer::Renderer()
{
    m_private = new RendererPrivate;
}

Renderer::~Renderer()
{
    delete m_private;
}

Animator* Renderer::animator() const
{
    return m_private->animator();
}

int Renderer::paintGLCounter() const
{
    return m_paintGLCounter;
}

void Renderer::setAnimator(Animator* a)
{
    m_private->setAnimator(a);
    assert("post: is_set" && animator() == a);
}

void Renderer::resetPaintGLCounter()
{
    m_paintGLCounter = 0;
    assert("post: is_zero" && paintGLCounter() == 0);
}

void Renderer::initializeGL()
{
    m_private->initializeGL();
}

void Renderer::paintGL()
{
    m_private->paintGL();
    ++m_paintGLCounter;
}

void Renderer::resizeGL(int w, int h)
{
    m_private->resizeGL(w, h);
}
