#pragma once

class Animator;

class RendererPrivate
{
  public:
    /// @name Initialization
    //@{
    /// Default constructor
    RendererPrivate();
    //@}

    /// @name Access
    //@{
    /// Object that compute time dependent parameters.
    Animator* animator() const;
    //@}

    /// @name Element change
    //@{
    /** \brief Replace animator() with `a'
     * - \post is_set: animator()==a
     */
    void setAnimator(Animator* a);
    //@}

    /// @name Basic operations
    //@{
    /// Same semantic as QGLWidget::initializeGL()
    void initializeGL();
    /// Same semantic as QGLWidget::paintGL()
    void paintGL();
    /// Same semantic as QGLWidget::resizeGL()
    void resizeGL(int w, int h);
    //@}
  protected:
    int m_width = 0;
    int m_height = 0;
    Animator* m_animator = nullptr;
};
