#include <QApplication>
#include <QGLFormat>
#include "MyQGLWidget.h"
#include "Renderer.h"
#include "Animator.h"

#include <iostream>

int main(int argc, char* argv[])
{
    int result = 0;

    QApplication app(argc, argv);

    QGLFormat format = QGLFormat::defaultFormat();
    // When fail on Mac, it does not pick a better format
    // format.setStereo(true);
    QGLFormat::setDefaultFormat(format);

    MyQGLWidget* w = new MyQGLWidget;
    Renderer* r = new Renderer;
    w->setRenderer(r);
    Animator* animator = new Animator;
    animator->setAngleVelocityDegreePerSecond(20.0f);
    r->setAnimator(animator);
    w->setAnimator(animator);

    w->show();

    std::cout << "Using Qt " << QT_VERSION_STR << std::endl;

    result = app.exec();

    return result;
}
