#include <QApplication>
#include <QSurfaceFormat>
#include "MyQOpenGLWindow.h"
#include "Renderer.h"
#include "Animator.h"

#include <iostream>

int main(int argc, char* argv[])
{
    int result = 0;

    QApplication app(argc, argv);

    QSurfaceFormat format = QSurfaceFormat::defaultFormat();
    // When fail on Mac, it does not pick a better format
    // format.setStereo(true);
    QSurfaceFormat::setDefaultFormat(format);
#if 1
    MyQOpenGLWindow* w = new MyQOpenGLWindow();
    Renderer* r = new Renderer;
    w->setRenderer(r);
    Animator* animator = new Animator;
    animator->setAngleVelocityDegreePerSecond(20.0f);
    r->setAnimator(animator);
    w->setAnimator(animator);

    w->resize(640, 480);
#else
    QOpenGLWindow* w = new QOpenGLWindow;
#endif
    w->show();

    std::cout << "Using Qt " << QT_VERSION_STR << std::endl;

    result = app.exec();

    return result;
}
