#pragma once

class QWindow;
class QWidget;

/** \brief Return the window handle attached to `w' or if it does not exist,
 * the one from the native parent of `w'.
 * - \pre w_exists: w!=nullptr
 */
QWindow* nativeWindowHandle(const QWidget* w);

/** \brief Return the device pixel ratio of the window attached to `w' or of
 * the one from the native parent of `w' or of the primary screen of the
 * application. If none is found, return 1.0.
 */
double widgetDevicePixelRatio(const QWidget* w);
